/***************************************************************************
 *   Copyright (C) 2007 by Lisandro Damián Nicanor Pérez Meyer             *
 *   perezmeyer@gmail.com                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CUBE_H
#define CUBE_H

#include "graphicprimitive.h"
#include "point4f.h"
#include "matrix.h"

/// This class implements a Cube

class Cube : public GraphicPrimitive
{
public:
	Cube();
	void draw(const Matrix4X4 & incomingMatrix, Matrix * zbuffer,
	          bool perspective, QImage * image);

private:
	Point4F rightTopBack;
	Point4F rightBottomBack;
	Point4F leftBottomBack;
	Point4F leftTopBack;

	Point4F rightTopFront;
	Point4F rightBottomFront;
	Point4F leftBottomFront;
	Point4F leftTopFront;
};

#endif // Cube
